#pragma once
#include <string>
namespace graft_cv{
typedef unsigned char byte;
typedef struct 
{
    int angle;
    int width;
    int height;
    byte *data;
}ImgInfo;

typedef struct{
	// Կ (5)
	bool image_show;//true--ʾемͼƬҪ˹سִܼ; false--ͼƬʾ
	bool image_return;//true--ؽpositoninfoӷصͼƬ; false--ͼƬ
	int image_row_grid;
	int image_col_grid;
	bool self_camera;

	// timeout (2)
	int timeout_proc; //ӿڴʱ䣬500ms
	int timeout_append; //100ms

	//image storage parameters(3)
	bool image_save;//Ƿ񱣴ͼ
	std::string image_depository;//ͼĿ¼
	int image_backup_days;//ͼɾ
	

	// optimal angle parameters (15)
	bool oa_y_flip;
	int oa_morph_radius;//optimal-angle, open-operation morph-size, = 1;-->COptimalAngle::imgproc(Mat& img)
	int oa_morph_iteration; //optimal-angle, open-operation times, = 5; -->COptimalAngle::imgproc(Mat& img)
	int oa_min_leaf_area; //СҶƬ
	//int oa_min_hist_value;// optimal-angle, columns-histogram, threshold; -->COptimalAngle::imgproc(Mat& img)
	//double oa_col_th_ratio;//  = 0.7, rootstock binary image column histogram, threshold ratio for max-value, for 
	                       // detect stem x-range
	//double oa_row_th_ratio; // = 1.2, row histogram of stem x-range subimage, stem diameter ratio for detect 
	                        // stem fork position
	//int oa_stem_x_padding; // = 20;
	//int oa_stem_dia_min;   //=20,  
    //int oa_stem_fork_y_min;//=10,ֲ㵽
	//double oa_stem_dia_mp;   //=0.8,
	//int oa_morph_radius_base;//ʶֵ
	//int oa_morph_iteration_base; //ʶֵ
	//int oa_min_hist_value_base;//ʶֵ
	//int oa_clip_y_min;//λϱԵyֵ
	//int oa_clip_y_max;//λ±Եyֵ

	
	//rootstock cut parameters (20)
	bool rs_y_flip;
	int   rs_min_hist_value;
	double rs_col_th_ratio;//  = 0.7, rootstock binary image column histogram, threshold ratio for max-value, for 
	                       // detect stem x-range
	double rs_row_th_ratio; // = 1.2, row histogram of stem x-range subimage, stem diameter ratio for detect 
	                        // stem fork position
	int rs_stem_x_padding; // = 20;
	int rs_stem_dia_min;   //=20,    
	double rs_stem_dia_mp;   //=0.8,
    int rs_stem_fork_y_min;//=10,ֲ㵽
	int rs_stem_edge_detect_window;//=5, Ե⣬ʱĴ
	                                //;أӦСھ֣
	double rs_cand_corner_box_width_ratio;//=3.0 ھfork㣬ҲԵΪο㣬ѡǵ, ֵı
	double rs_cand_corner_box_xoffset_ratio;//=-10,cand_corner_box xƫ ֵı
	double rs_opt_corner_xoffset_ratio;//=0.75, иǵ㣬οľ룬뾥ֵıʣҲ
	                            // иοмľ
	double rs_opt_corner_yoffset_ratio;
	double rs_corner_mask_rad_ratio;//ֵͼǵ󣬶ǵģ뾶ϵΪֵļ
	 
	int rs_morph_radius;//=1, open-operation morph-size, = 1;-->COptimalAngle::imgproc(Mat& img)
	int rs_morph_iteration;// = 2
	int rs_morph_iteration_gray;//=5
	int rs_max_corner_num;//=100;
	double rs_corner_qaulity_level;// = 0.1;
	double rs_corner_min_distance;// = 10;
	double rs_cut_angle; //=-135 иΪģķ򣬣-180.0180.0
	double rs_cut_point_offset_ratio;//ƫƱڽԲ뾶ı0-1.0	

	//scion cut parameters (14)
	bool sc_y_flip;
	double sc_col_th_ratio;//  = 0.7, scion binary image column histogram, threshold ratio for max-value, for 
	                      // detect stem x-range
	double sc_row_th_ratio; // = 0.66, row histogram of stem x-range subimage, stem diameter ratio for detect 
	                       // stem fork position, x0----x1ΧںͶӰͶӰֵԣx1-x0ڴϵҵ߽
	int sc_stem_x_padding; // = 50; 
	int sc_stem_dia_min;   //=20,    
	int sc_clip_padding;//=5 ¼¿ʼ
	int sc_stem_ymax_padding;//=50 һμ⵽¶ˣӰ죬ƫСӴⷶΧ
	int sc_default_cut_length;//ûҵfold_pointֱӹƳfold_point

	int sc_stem_edge_detect_window;//=5, Ե⣬ʱĴ
	                               //;أӦСھ֣
	double sc_r2_th; //threshold for r2 ratio
	int sc_r2_window; //= 5; the radius for calculate r2 index
	int sc_average_window;// =10; 
	int sc_morph_radius;//scion, open-operation morph-size, = 1;-->COptimalAngle::imgproc(Mat& img)
	int sc_morph_iteration; //scion, open-operation times, = 5; -->COptimalAngle::imgproc(Mat& img)
	 
	// camera pixel ratio (3)
	double rs_oa_pixel_ratio; // rootstock optimal-angle camera pixel ratio for millimeter, mm/piexel
	double rs_cut_pixel_ratio; // rootstock cutting camera  pixel ratio for millimeter, mm/piexel
	double sc_cut_pixel_ratio; // scion cutting camera  pixel ratio for millimeter, mm/piexel
	
	// rootstock grab based points cloud
	double rs_grab_xmin;
	double rs_grab_xmax;
	double rs_grab_ymin;
	double rs_grab_ymax;
	double rs_grab_zmin;
	double rs_grab_zmax;

	double rs_grab_stem_diameter;	
	double rs_grab_y_opt;
	double rs_grab_seedling_dist;
	int rs_grab_stem_min_pts;

	// scion grab based points cloud
	double sc_grab_xmin;
	double sc_grab_xmax;
	double sc_grab_ymin;
	double sc_grab_ymax;
	double sc_grab_zmin;
	double sc_grab_zmax;

	double sc_grab_stem_diameter;
	double sc_grab_y_opt;
	double sc_grab_seedling_dist;
	int sc_grab_stem_min_pts;



} ConfigParam;

typedef struct 
{
	//漰λþΪʵλã
	double rs_grab_x;//ľץȡλx
	double rs_grab_y;//ľץȡλy
	double rs_grab_z;//ľץȡλz

	double rs_oa;//ľŽǶ
	//double rs_oa_base;//ľŽǶ
	//double rs_oa_stem_y_fork;//ֲy
	//double rs_oa_clamp_y_end;//¶y
	//int rs_oa_width;//ÿһ֡Ҷչ
	//int rs_oa_width_base;//ÿһ֡ػʿ
	
	double rs_cut_upoint_x;//ľиxλã
	double rs_cut_upoint_y;//ľиyλã
	double rs_stem_diameter;//ľ֣	
	double rs_cut_lpoint_x;//ľиxλã
	double rs_cut_lpoint_y;//ľиyλã
	char rs_img_id[64]; 
	double rs_reid_upoint_x;//кľиxλã
	double rs_reid_upoint_y;//кľиyλã
	double rs_reid_lpoint_x;//кľиxλã
	double rs_reid_lpoint_y;//кľиyλã

	double rs_reid_sola_upoint_x;//ѿкľиxλã
	double rs_reid_sola_upoint_y;//ѿкľиyλã
	double rs_reid_sola_cpoint_x;//ѿкľиxλã
	double rs_reid_sola_cpoint_y;//ѿкľиyλã
	double rs_reid_sola_lpoint_x;//ѿкľиxλã
	double rs_reid_sola_lpoint_y;//ѿкľиyλã

	double sc_reid_sola_upoint_x;//ѿкиxλã
	double sc_reid_sola_upoint_y;//ѿкиyλã
	double sc_reid_sola_cpoint_x;//ѿкиxλã
	double sc_reid_sola_cpoint_y;//ѿкиyλã
	double sc_reid_sola_lpoint_x;//ѿкиxλã
	double sc_reid_sola_lpoint_y;//ѿкиyλã




	double sc_cut_upoint_x;//иxλã
	double sc_cut_upoint_y;//иyλã
	double sc_cut_cpoint_x;//иеxλã
	double sc_cut_cpoint_y;//иеyλã
	double sc_cut_lpoint_x;//иµxλã
	double sc_cut_lpoint_y;//иµyλã
	
	ImgInfo* pp_images[5];//οͼƬֻǰûеĻᱻ
	
}PositionInfo;


};